/* Aggregate lowest level of merch, time, location up merch, loc, time hierarchies */
/* Assumes parent mid_*, lid_*, and tid_* ids are present for all levels between from and to levels for each dimension */
 
%macro aggregation(in=,out=,numkpis=,kpilist=,m_from=,m_to=,l_from=,l_to=,t_from=,t_to=,do_m=1,do_l=1,do_t=1,cluster_id=0);
 
%let kpis=;
%do k=1 %to &numkpis.;
%let kpis=&kpis. sum(%sysfunc(KSCAN(%quote(&kpilist.),%eval(&k.*2)))) as %sysfunc(KSCAN(%quote(&kpilist.),%eval(&k.*2))),;
%end;
 
%let lids=cluster,;
%if &l_from.>1000
%then %let l_new_from=4;
%else %do;
%let l_new_from=&l_from.;
%do k=&l_new_from. %to &l_to.;
%let lids=&lids lid_&k.,;
%end;
%end;
 
 
%let tids=;
%do i=&t_from. %to &t_to.;
%let tids=&tids tid_&i.,;
%end;
 
 
%put &kpis;
 
/* Merchandise Aggregation */
%if &do_m.=0 %then %do;
%let next_tab=&in.;
%end;
%else %do;
proc sql noprint;
%do m=&m_from. %to &m_to.;
/* skip merch levels */
%if &m<=&dfr_maxmerch or &m=&m_to. %then %do;
%if &m=&m_from.
%then %do; create table &in._m as %end;
%else %do; insert into &in._m %end;
 
select &kpis &lids &tids mid_&m. as merch_id, &m as merch_level, location_id, location_level, time_id, time_level
from &in.
group by &lids &tids mid_&m., location_id, location_level, time_id, time_level;
%end;
%end;
quit;
%let next_tab=&in._m;
%end;
 
/* Location Aggregation */
%if &do_l.=1 %then %do;
proc sql noprint;
%let instatic=0;
 
/* static locations including store */
%if (&l_from.<1000) or (&l_to.=4) %then %do;
%let instatic=1;
%do l=&l_new_from. %to &l_to.;
%if &l=&l_new_from.
%then %do; create table &in._l as %end;
%else %do; insert into &in._l %end;
 
select &kpis. &tids. lid_&l. as location_id, &l as location_level, merch_id, merch_level, time_id, time_level
from &next_tab.
group by &tids. lid_&l, merch_id, merch_level, time_id, time_level;
%end;
%end;
 
%if &l_from.>1000 %then %do;    /* from cluster set to cluster or store */
/* Aggregate to cluster set id */
%if &instatic.=0
%then %do; create table &in._l as %end;
%else %do; insert into &in._l %end;
select &kpis. &tids. &cluster_id. as location_id, 1001 as location_level, merch_id, merch_level, time_id, time_level
from &next_tab.
group by &tids. merch_id, merch_level, time_id, time_level;
 
/* agg to cluster */
%if &l_from.=1001 %then %do;
insert into &in._l select &kpis. &tids. cluster as location_id, 1002 as location_level, merch_id, merch_level, time_id, time_level
from &next_tab.
group by &tids. cluster, merch_id, merch_level, time_id, time_level;
%end;
%end;
 
quit;
%let next_tab=&in._l;
%end;
 
/* Time Aggregation */
%if &do_t.=1 %then %do;
proc sql noprint;
%do t=&t_from. %to &t_to.;
%if &t=&t_from.
%then %do; create table &in._t as %end;
%else %do; insert into &in._t %end;
 
select &kpis. merch_id, merch_level, location_id, location_level, tid_&t. as time_id, %eval(&t.+46) as time_level
from &next_tab.
group by tid_&t., merch_id, merch_level, location_id, location_level;
%end;
quit;
%let next_tab=&in._t;
%end;
 
/* write out final dataset*/
data &out. (drop= mid_: lid_: tid_:);
set &next_tab.;
run;
 
%mend;
