/**************************************************************/
/*                                                            */
/*       SAS RETAIL INTELLIGENCE SOLUTIONS					  */
/* 		 Demand Forecast For Retail Planning 4.2       		  */
/*                                                            */
/**************************************************************/
/*                                                            */
/* SAS Retail Group, All rights reserved (c) 2006,2007        */
/*                                                            */
/**************************************************************/
 
/*****************************************************************************************************************/
/*Functionality- Combine different KPIs into single dataset */
/*****************************************************************************************************************/
 
%macro combine1();
 
%if (&recon_single.=1) or (&recon_hier.=1 ) %then %do; /*For Merchandise reconcilliation and singal level*/
	%let var_by=m_lvl l_lvl kpi;
	%let var_bg=l_lvl;
%end;
 
%if &recon_hier.=2 %then %do; /*For locationn reconcilliation*/
	%let var_by=l_lvl m_lvl kpi;
	%let var_bg=m_lvl;
%end;
 
PROC SORT data=dp.F_&proj._forecast_meta out=dp.F_&proj._forecast_meta nodupkey;
	by &var_by;
run;
%RCSet (&syserr);
 
/*Temporary SAS program */
filename tmp temp;
 
/*This will merge all the KPIs in a single dataset per level*/
 
data _null_;
	set dp.F_&proj._forecast_meta ;
	by &var_by;
	length v $2000;
	file tmp;
	if first.&var_bg then do;
		v= 'data out.RM_F_'||strip(&proj.) ||'_M' || strip(m_lvl) ||'_L' || strip(L_lvl) ||';';
		put v;
		if &dfr_wf_recon NE 0 and (&&&RECON_DIM._to_level ne &&&RECON_DIM._from_level) then v=' set recon.' ||strip(KSUBSTR(ds_name,2)) ; else v=' set recon.' || strip(ds_name);
			put v;
	end;
	if last.&var_bg=1 and first.&var_bg=0 then do;
		if &dfr_wf_recon NE 0 and (&&&RECON_DIM._to_level ne &&&RECON_DIM._from_level) then v=' recon.' ||strip(KSUBSTR(ds_name,2))||';' ; else v=' recon.' ||strip(ds_name)||';';
			put v;
	end;
	if last.&var_bg then do;
		put ';run;';
	end;
	if last.&var_bg=0 and first.&var_bg=0 then do;
		if &dfr_wf_recon NE 0 and (&&&RECON_DIM._to_level ne &&&RECON_DIM._from_level) then v=' recon.' ||strip(KSUBSTR(ds_name,2)) ; else v=' recon.' ||strip(ds_name);
			put v;
	end;
run;
%RCSet (&syserr);
 
/*To execute  temporary SAS program*/
%include tmp;
 
/*Updating the control table for process flag*/
data dp.F_&proj._ctrl_tab ;
	set  dp.F_&proj._ctrl_tab ;
	if umd_dia-hist_dia > 0 or
	umd_fit-hist_fit > 0 or
	umd_sel-hist_sel > 0 or
	umd_for-hist_for > 0 then process=1; else process=0;
run;
%RCSet (&syserr);
 
/*Clear WORK library*/
proc datasets library=work kill nodetails nolist;
quit;
proc datasets library=W_&wktid. kill nodetails nolist;
quit;
 
%mend;
 
