%macro ABT_Creation();
%global fcast_merch_to_level fcast_loc_from_level fcast_loc_to_level merch_to_level loc_to_level loc_from_level except_loc_to_level except_merch_to_level;
	/********************************************************************************************/
	/********************************************************************************************/
	/************************************** DATA EXTRACT ****************************************/
	/********************************************************************************************/
	/********************************************************************************************/
	 
	%if (&dfr_wf_extract.>0) and (&job_rc<5) %then %do;
		%if (&dfr_wf_extract.=1) and (&standalone ^= 1) %then %do;
			%dfr_extract;
		%end;

		/* =1 extract from Merchandise Planning; =2 extract from SAS input folder dataset, =3 extract data from input folder .csv file */
		%else %if (&dfr_wf_extract.=2) or (&dfr_wf_extract.=3) %then %do;
		    Data inp.f_&projid.;
			%if (&dfr_wf_extract.=2) %then %do;
		    	set inp.fx_&projid.;
		    	%end;
		    %else %if (&dfr_wf_extract.=3) %then %do;
				infile "&path_input/fx_&projid..csv" delimiter=',' missover;
				input 
					/* lid/mid expected at all levels from/to for merch/loc */
				    %do k=1 %to &merch_to_level.;
						mid_&k. 
					%end;
				    %do k=1 %to &loc_to_level.;
						lid_&k. 
					%end;
					/*	time_id=;*/
					time_&time_to_level. date9.

				    /* loop for each dfr_kpinameset vars and dfr_ind_vars*/
				    %do k=1 %to &dfr_numkpis.;
						%sysfunc(kscan(%quote(&dfr_kpinameset.),&k.))
			        	%end;
					%let f=1;
					%let afield = %sysfunc(kscan(%quote(&dfr_ind_var.),&f,%str(,)));
					%do %while (&afield ne);
						%sysfunc(kscan(%quote(&afield.),3))
						%let f = %eval(&f+1);
						%let afield = %sysfunc(kscan(%quote(&dfr_ind_var.),&f,%str(,)));
						%end;
					;
				%end;

			merch_level=&merch_to_level.;
			location_level=&loc_to_level.;
			time_level=&real_time_to_level.;
			merch_id=mid_&merch_to_level.;
			location_id=lid_&loc_to_level.;
			cluster=0;
		    run;
		%end;
		/*Add future records equal to number of periods in dfr_horizon*/
		%if (&job_rc<5) and (&dfr_wf_newitem. ne 3) and (&dfr_wf_newitem. ne 4) %then %do;
				%add_future_records(ip=inp.f_&projid.);
		%end;
		%mm_step_finish(proj=&projid.,step=extract,standalone=&standalone.);
	%end;

	%if (&dfr_wf_newitem.=3) or (&dfr_wf_newitem.=4) or (&job_rc.>4) %then %do;
		%goto close_out;
	%end;

	/* Set to levels to skip any skipped levels */
	%let fcast_merch_to_level=&merch_to_level.;
	%let fcast_loc_from_level=&loc_from_level.;
	%let fcast_loc_to_level=&orig_loc_to_level.;
	%let merch_to_level=&m_lev.;
	%let loc_to_level=&l_lev.;
	%let loc_from_level=&locfrom.;
	%let except_merch_to_level=&m_lev.;
	%let except_loc_to_level=&l_lev.;
	%put EXTRACT RC:&job_rc EXTRACT_WF:&dfr_wf_extract;

	 data mmdata.Jobparam_&projid._copy;
		set mmdata.Jobparam_&projid.;
	 run;
	 proc sql noprint;
	 	update mmdata.jobparam_&wktid. set value="&merch_to_level." where Klowcase(name)='merch_to_level';
		update mmdata.jobparam_&wktid. set value="&loc_to_level." where Klowcase(name)='loc_to_level';
		update mmdata.jobparam_&wktid. set value="&loc_from_level." where Klowcase(name)='loc_from_level';
	 quit;

	%timecheck(step=%quote(EXTRACT));
	/*Set-up group-key=0 if dfr_user_define_gk=0 */
	%if &dfr_user_define_gk=0 %then %do;
		data inp.f_&projid.;
			set inp.f_&projid.;
			group_key=0;
		run;
	%end;
	 
	/* EXIT if only performing history imports for new items */
	%if (&dfr_wf_newitem.=3) or (&dfr_wf_newitem.=4) %then %do;
		%goto close_out;
	%end;

	/* Format Creation if Optimization is OFF. */
	%if &dfr_wf_extract. eq 1 %then %do;
		%create_format(projid=&proj.);
	%end;

	/* include dfr pre-and post forecast process code */
	%include "&path_pgm.&slash.dfrcode&slash.risini.sas";   /* secondary parameter setup */
	/*Code to attach event indicator*/
	%if "&dfr_ext_event_file." ne "" %then %do;
		%ImportEventData(csvfile=&path_data&slash.input&slash.&dfr_ext_event_file,out=inp.event_ext_&projid.);
		%create_event;
	%end;

	/*************************************************************************************/
	/*************************************************************************************/
	/* Add Secondary Effects to the dataset f_[projid] */
	/*************************************************************************************/
	/*************************************************************************************/
	%if (&dfr_wf_dataprep.>0) and (&job_rc<5) and ("&dfr_data_effect_list" ne "" ) %then %do;		
		%dfr_data_gen;
	%end;
	 
	%put DATAPREP &job_rc &dfr_wf_dataprep;
	%timecheck(step=%quote(DATA GEN));

	%close_out:
%mend;
