/**************************************************************/
/*                                                            */
/*       SAS RETAIL INTELLIGENCE SOLUTIONS					  */
/* 		 Demand Forecast For Retail Planning 4.2       		  */
/*                                                            */
/**************************************************************/
/*                                                            */
/* SAS Retail Group, All rights reserved (c) 2006,2007        */
/*                                                            */
/**************************************************************/

/****************************************************/
/*	Functionality- Calls to intel_workflow macro 	*/
/****************************************************/

%macro Run_intel_workflow();
/* Get merch/location levels and KPI combinations to Forecast. One combination per row */
	data _null_;
		set Dp.F_&proj._meta end=L;
		if L then call symput('row_no',_n_);
	run;
	%RCSet (&syserr);

	%global row_number;
	%let row_number=0;
	/*Deleting observations*/
	proc sql noprint;
		select COUNT(*) into :row_number from inp.F_&proj.
		where &dfr_time_field. ge (&dfr_horizonstart.- (&revisit_obs. * &dfr_interval_no.));
	quit;
	%RCSet (&syserr);

/*Following code get execute "intel_workflow" for every row in metadata table*/
	%do i=1 %to &row_no; /*Start of each row execution*/
		%if &job_rc <= 4 %then %intel_workflow(proj=&proj.,row=&i.,row_number=&row_number.);
	%end; /*End of each row execution*/
%mend Run_intel_workflow;
