insert into maxdata.fcast_version (FCAST_VERSION_ID, FCAST_VERSION_NM) values (1,'Orig Forecast');
insert into maxdata.fcast_version (FCAST_VERSION_ID, FCAST_VERSION_NM) values (2,'Curr Forecast');
commit;

create  view maxdata.ma_merch_levels as select level_id-10 as id, level_name as name from maxdata.hier_level where hier_id=11 union all Select 0 as id, 'NONE' as name from maxapp.mmax_config;
create  view maxdata.ma_loc_levels as select level_id as id, level_name as name from maxdata.hier_level where hier_id=1 union all Select 0 as id, 'NONE' as name from maxapp.mmax_config;
create  view maxdata.ma_time_levels as select level_id-46 as id, level_name as name from maxdata.hier_level where hier_id=50 union all Select 0 as id, 'NONE' as name from maxapp.mmax_config;

alter table maxdata.planworksheet add analytic_lkup_id numeric(6) default 0;
alter table maxdata.planworksheet add analytic_err_id numeric(6) default 0;

alter table maxdata.planworksheet add fcast_version numeric(6) default 1;
alter table maxdata.planworksheet add fcast_newitem numeric(2) default 0;
alter table maxdata.planworksheet add fcast_recon_hier numeric(6) default 0;
alter table maxdata.planworksheet add fcast_recon_merch numeric(6) default 0;
alter table maxdata.planworksheet add fcast_recon_loc numeric(6) default 0;
alter table maxdata.planworksheet add fcast_reconcile numeric(6) default 0;

alter table maxdata.mfact_version add fc_sales_r numeric(18,5);
alter table maxdata.mfact_version add fc_sales_u numeric(18,5);
alter table maxdata.mfact_version add fc_std numeric(18,5);
alter table maxdata.mfact_version add fc_std_u numeric(18,5);

alter table lv4loc add acts_like numeric(10);

alter table maxdata.lv6ctree add acts_like1 numeric(10);
alter table maxdata.lv6ctree add acts_like2 numeric(10);
alter table maxdata.lv6ctree add acts_like3 numeric(10);
alter table maxdata.lv6ctree add act_parent_lev numeric(3);
alter table maxdata.lv6ctree add act_pct_adjust numeric(10, 3);
alter table maxdata.lv6ctree add act_start_date date;
alter table maxdata.lv6ctree add act_end_date date;

create view maxdata.actslike_lkup as 
select lv6ctree_id as id, lv6cmast.name as name, 
lv2cmast.name as lineofbusiness, lv3cmast.name as Department, lv4cmast.name as Category, lv5cmast.name as Subcategory,
lv6cmast.user_attrib31 as sleevelength, 
lv6cmast.user_attrib43 as silhouette, 
lv6cmast.user_attrib42 as fashionbasic, 
lv6cmast.user_attrib41 as topbottom
from maxdata.lv6cmast, maxdata.lv6ctree, 
maxdata.lv2cmast, maxdata.lv2ctree,
maxdata.lv3cmast, maxdata.lv3ctree,
maxdata.lv4cmast, maxdata.lv4ctree,
maxdata.lv5cmast, maxdata.lv5ctree
where lv6ctree.lv6cmast_id=lv6cmast.lv6cmast_id 
and lv5ctree.lv5cmast_id=lv5cmast.lv5cmast_id and lv6ctree.lv5ctree_id = lv5ctree.lv5ctree_id
and lv4ctree.lv4cmast_id=lv4cmast.lv4cmast_id and lv6ctree.lv4ctree_id = lv4ctree.lv4ctree_id
and lv3ctree.lv3cmast_id=lv3cmast.lv3cmast_id and lv6ctree.lv3ctree_id = lv3ctree.lv3ctree_id
and lv2ctree.lv2cmast_id=lv2cmast.lv2cmast_id and lv6ctree.lv2ctree_id = lv2ctree.lv2ctree_id;
