drop table maxapp.batch_analytic_lkup;
create table maxapp.batch_analytic_lkup (analytic_lkup_id numeric(6), analytic_name varchar2(60), macroname varchar2(60));
insert into maxapp.batch_analytic_lkup (analytic_lkup_id, analytic_name, macroname) values (0,'None','');
insert into maxapp.batch_analytic_lkup (analytic_lkup_id, analytic_name, macroname) values (1,'Forecast 1','mm_forecast');

insert into maxdata.fcast_version (FCAST_VERSION_ID, FCAST_VERSION_NM) values (1,'Orig Forecast');
insert into maxdata.fcast_version (FCAST_VERSION_ID, FCAST_VERSION_NM) values (2,'Curr Forecast');
commit;

create or replace view maxdata.ma_merch_levels as select level_id-10 as id, level_name as name from maxdata.hier_level where hier_id=11 union all Select 0 as id, 'NONE' as name from maxapp.mmax_config;
create or replace view maxdata.ma_loc_levels as select level_id as id, level_name as name from maxdata.hier_level where hier_id=1 union all Select 0 as id, 'NONE' as name from maxapp.mmax_config;
create or replace view maxdata.ma_time_levels as select level_id-46 as id, level_name as name from maxdata.hier_level where hier_id=50 union all Select 0 as id, 'NONE' as name from maxapp.mmax_config;

drop table maxapp.ma_mlt;
create table maxapp.ma_mlt (id numeric(5), name varchar(40));
insert into maxapp.ma_mlt values (1,'Merchandise');
insert into maxapp.ma_mlt values (2,'Location');

drop table maxapp.newitem_lkup;
create table maxapp.newitem_lkup (id numeric(5), name varchar(40));
insert into maxapp.newitem_lkup values ('0','None');
insert into maxapp.newitem_lkup values ('1','Merge History before Forecast');
insert into maxapp.newitem_lkup values ('2','Merge History with Forecast');
insert into maxapp.newitem_lkup values ('3','All History');
insert into maxapp.newitem_lkup values ('4','New Product History');

insert into maxapp.bv_kpitype_lkup values (17,'New Product',NULL);

alter table maxdata.planworksheet add analytic_lkup_id numeric(6) default 0;
alter table maxdata.planworksheet add analytic_err_id numeric(6) default 0;

alter table maxdata.planworksheet add fcast_version numeric(6) default 1;
alter table maxdata.planworksheet add fcast_newitem numeric(2) default 0;
alter table maxdata.planworksheet add fcast_reconcile numeric(6) default 0;
alter table maxdata.planworksheet add fcast_recon_hier numeric(6) default 0;
alter table maxdata.planworksheet add fcast_recon_merch numeric(6) default 0;
alter table maxdata.planworksheet add fcast_recon_loc numeric(6) default 0;

alter table maxdata.mfact_version add (fc_sales_r numeric);
alter table maxdata.mfact_version add (fc_sales_u numeric);
alter table maxdata.mfact_version add (fc_std numeric(18,5));
alter table maxdata.mfact_version add (fc_std_u numeric(18,5));

alter table maxdata.lv6ctree add (
	acts_like1 numeric(10),
	acts_like2 numeric(10),
	acts_like3 numeric(10),
	act_parent_lev numeric(3),
	act_pct_adjust numeric(10,3),
	act_start_date date,
	act_end_date   date
);

alter table lv4loc add acts_like numeric(10);
commit;


create or replace view actslike_lkup as
select lv6ctree_id as id, lv6cmast.name as name, 
lv2cmast.name as lineofbusiness, lv3cmast.name as Department, lv4cmast.name as Category, lv5cmast.name as Subcategory,
lv6cmast.user_attrib31 as sleevelength, 
lv6cmast.user_attrib43 as silhouette, 
lv6cmast.user_attrib42 as fashionbasic, 
lv6cmast.user_attrib41 as topbottom
from maxdata.lv6cmast, maxdata.lv6ctree, 
maxdata.lv2cmast, maxdata.lv2ctree,
maxdata.lv3cmast, maxdata.lv3ctree,
maxdata.lv4cmast, maxdata.lv4ctree,
maxdata.lv5cmast, maxdata.lv5ctree
where lv6ctree.lv6cmast_id=lv6cmast.lv6cmast_id 
and lv5ctree.lv5cmast_id=lv5cmast.lv5cmast_id and lv6ctree.lv5ctree_id = lv5ctree.lv5ctree_id
and lv4ctree.lv4cmast_id=lv4cmast.lv4cmast_id and lv6ctree.lv4ctree_id = lv4ctree.lv4ctree_id
and lv3ctree.lv3cmast_id=lv3cmast.lv3cmast_id and lv6ctree.lv3ctree_id = lv3ctree.lv3ctree_id
and lv2ctree.lv2cmast_id=lv2cmast.lv2cmast_id and lv6ctree.lv2ctree_id = lv2ctree.lv2ctree_id;


drop table maxdata.dfr_fact_tables;

CREATE TABLE MAXDATA.DFR_FACT_TABLES
   (	"MMX_TBL_NAME" VARCHAR2(30), 
	"MMX_COL_NAME" VARCHAR2(30), 
	"MERCH_AGG_RULE" VARCHAR2(30), 
	"LOC_AGG_RULE" VARCHAR2(30), 
	"TIME_AGG_RULE" VARCHAR2(30)
   );

insert into DFR_FACT_TABLES (MMX_TBL_NAME, MMX_COL_NAME, MERCH_AGG_RULE, LOC_AGG_RULE, TIME_AGG_RULE)
values ('MFACT_VERSION', 'FC_SALES_R', 'SUM', 'SUM', 'SUM');
insert into DFR_FACT_TABLES (MMX_TBL_NAME, MMX_COL_NAME, MERCH_AGG_RULE, LOC_AGG_RULE, TIME_AGG_RULE)
values ('MFACT_VERSION', 'FC_STD', 'AVG', 'AVG', 'AVG');
insert into DFR_FACT_TABLES (MMX_TBL_NAME, MMX_COL_NAME, MERCH_AGG_RULE, LOC_AGG_RULE, TIME_AGG_RULE)
values ('MFACT_VERSION', 'FC_STD_U', 'AVG', 'AVG', 'AVG');
insert into DFR_FACT_TABLES (MMX_TBL_NAME, MMX_COL_NAME, MERCH_AGG_RULE, LOC_AGG_RULE, TIME_AGG_RULE)
values ('MFACT_VERSION', 'FC_SALES_U', 'SUM', 'SUM', 'SUM');
commit;

CREATE OR REPLACE Function GetNumber(vColName in varchar2)
return integer
is
iColTest number;
begin
	iColTest := to_number(trim(vColName));
	return iColtest;
	exception
	when others then return 0;
end; 
/
commit;



CREATE OR REPLACE Procedure p_add_partitions_mfversion ( iStartYear Number, iEndYear Number,
iFvVersionId number)
as
v_sql long;
vPartitionName Varchar2(30);
vSubPartitionName Varchar2(30);
iCtr Number;
vNextPartName varchar2(30);
iNextTimeLevel Number;
iNextTimeId Number;
jctr Number;
begin

For c1 in 
(
select 47 as time_level, lv1time_lkup_id as time_id from 
        maxapp.lv1time where cycle_id between iStartYear and iEndYear
    union all
    select 48 as time_level, lv2time_lkup_id as time_id from 
        maxapp.lv2time where cycle_id between iStartYear and iEndYear
    union all
    select 49 as time_level, lv3time_lkup_id as time_id from 
        maxapp.lv3time where cycle_id between iStartYear and iEndYear
    union all
    select 50 as time_level, lv4time_lkup_id as time_id from 
        maxapp.lv4time where cycle_id between iStartYear and iEndYear
    union all
    select 51 as time_level, lv5time_lkup_id as time_id from 
        maxapp.lv5time where cycle_id between iStartYear and iEndYear
    order by 1 asc, 2 asc
    ) loop
    
  
vPartitionName := 'MFVER_'||c1.time_level||'_'||c1.time_id;
vSubPartitionName := 'MFVER_'||c1.time_level||'_'||c1.time_id||'_'||iFvVersionId;

Select count(*) into ictr from all_tab_partitions where table_name = 'MFACT_VERSION'
and partition_name = vPartitionNAme;

if ictr = 0 then


Select  nvl(min(b.partition_position), 0) into jCtr from 
 (  Select partition_name, partition_position
            from all_tab_partitions where table_name = 'MFACT_VERSION' 
            and table_owner = 'MAXDATA'
  and partition_name not like '%DEFAULT%'  ) b
  where 
              (getnumber(substr(partition_name, 7, 2)) = c1.time_level and 
                getnumber(substr(partition_name, 10)) >= c1.time_id) OR
              getnumber(substr(partition_name, 7, 2)) > c1.time_level   ;
              

if jctr = 0 then

        v_sql := ' Alter Table MFACT_VERSION 
        add partition '||vPartitionName||' values less than ('||c1.time_level||', '||(c1.time_id + 1)||')
        (subpartition '||vSubPartitionName ||' Values ('||iFvVersionId||'))';
        insert into t_log values (v_sql);
        commit;
        execute immediate v_sql;


else
     Select partition_name into vNextPartName
            from all_tab_partitions where table_name = 'MFACT_VERSION' 
            and table_owner = 'MAXDATA'
            and  partition_position = jctr;

    iNextTimeLevel := c1.time_level;
    iNextTimeId := c1.time_id + 1;
    
    
    v_sql := ' alter table mfact_version split partition '||vNextPartName||' at ('||iNextTimeLevel||', '||iNextTimeId||')
into (partition '||vPartitionName||', partition '||vNextPartName ||')';
insert into t_log values (v_sql);
        commit;
    execute immediate v_sql;
   
end if;

end if;

    Select count(*) into ictr from all_tab_subpartitions where table_name = 'MFACT_VERSION'
    and subpartition_name = vsubPartitionNAme and table_owner = 'MAXDATA';
    
    if ictr = 0 then
    
        v_sql := ' Alter Table MFACT_VERSION modify partition '||vPartitionName||' 
        add subpartition '||vSubpartitionName||' values ('||iFvVersionId||')';
        insert into t_log values (v_sql);
        commit;
        execute immediate v_sql;
    end if;
    
end loop;

end; 
/
commit;
