/******************************/
/******* SYSTEM PARAMETERS ****/
/******************************/

%let slash=/;
%let delaysec=5;            /* Server poll delay */
%global dsn path_pgm path_data dbtype path_input path_output path_archive path_stage path_report dbpassword LOCAL;
options nodate dsnferr mstored nosymbolgen NOSYNTAXCHECK NODMSSYNCHK mcompilenote=all sasmstore=catalog;
%let LOCAL=en_us;

/*  Set metadata options to specify the server. */
%let BIMetaDataHost=HOST_NAME; /* Address of the SAS Metadata Server */
%let BIMetaDataPort=XXXX; /* TCP port for the SAS Metadata Server */
%let BIMetaProtocol=BRIDGE; /* Network protocol for communicating with the SAS Metadata Server */
%let BIMetaDataRepos=Foundation; /* Default SAS Metadata Repository to use on the SAS Metadata Server */
%let BIMetaDataUser=sasadm; /* Default user for logging onto the SAS Metadata Server */
%let BIMetaDataPassword=Password1; /* Default password for the SAS Metadata Server */
%let ShareServerHost=HOST_NAME; /* Address of the SAS Metadata Server */
%let Share_Server_Name=__XXXX; /*Name of the Share server*/
%let Share_Server_User=sasadm; /* Share Server User */
%let Share_Server_Password=Password1; /* Password for Share Server User. */
%let BIMetaServerName=SASMain; /* SAS Metadata server Name.*/

/*****************************************************/
/** SET PROGRAM CODE PATH ****************************/
/*****************************************************/
%let path_pgm=C:\SAS\Retail\mx_analytics;

/*  Set at least path_data and override subfolders if required */
%let path_data=C:\SAS\Retail\mx_analytics\Data;

/* Report Data folder */
%let path_report=C:\SAS\Retail\mx_analytics\Reports;

/********************************************************/
/** SET DATA PATHS **************************************/
/********************************************************/
/*Eminer dataset folder*/
%let IC_EM_data=&path_data.;

/* Plots Data folder */
%let path_plots=&path_report.&slash.plots;

/* Input Data folder */
%let path_input=&path_data.&slash.input;

/* Output Data folder */
%let path_output=&path_data.&slash.output;

/* Stage Data folder */
%let path_stage=&path_data.&slash.staged;

/* Archive Data folder */
%let path_archive=&path_data.&slash.archive;

/* Interim Data folder */
%let path_interim=&path_data.&slash.interim;

%let path_macro_catalog=&path_data.&slash.macro_catalog;
/***************************************************************************************/
/** SET MERCHANDISE INTELLIGENCE DATABASE TYPE AND PASSWORD ****************************/
/***************************************************************************************/
options noconnectpersist;	
options noconnectwait;
options metaserver=&BIMetaDataHost;
options metaport=&BIMetaDataPort;
options metarepository=&BIMetaDataRepos;
options metauser=&BIMetaDataUser;
options metapass=&BIMetaDataPassword;

%let dbtype=oracle;
*%let dbpassword="{sas001}bWFkbWFyeQ==";
%let dbpassword=madmary;
%let dsn=&sysparm.;

/* Oracle */

libname maxdata &dbtype. user=maxdata orapw=&dbpassword. path=&dsn. schema=maxdata;
libname maxapp &dbtype. user=maxapp orapw=&dbpassword. path=&dsn. schema=maxapp;

/* DB2 
%let dbtype=db2;
libname maxdata &dbtype. user=damath password=damath database=&dsn. schema='maxdata';
libname maxapp &dbtype. user=damath password=damath database=&dsn. schema='maxapp';
*/

/* Libraries ... Do Not Modify */
libname mmdata "&path_data.";
libname inp "&path_input.";
libname out "&path_output.";
libname stage "&path_stage.";
libname interim "&path_interim.";
libname archive "&path_archive.";
libname report "&path_report.";
libname dp "&path_interim&slash.dp" SERVER=&share_server_name HOSTNAME="&ShareServerHost" user="&Share_Server_User" passwd="&Share_Server_Password";
libname dia "&path_interim&slash.dia";
libname for "&path_interim&slash.for";
libname recon "&path_interim&slash.recon";
libname catalog "&path_macro_catalog";


options sasautos=('SASEnvironment/sasMacro', SASAUTOS, "&path_pgm./dfrcode", "&path_pgm./macode", "&path_pgm./wacode", "&path_pgm./recplancode", "&path_pgm./countcode", "&path_pgm./iccode" );

/* Include Utilities */
%include "&path_pgm./macode/utils2.sas";
/*%include "&path_pgm./macode/data_utils.sas";*/
